/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/virtualMachineImagesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a VirtualMachineImages. */
var VirtualMachineImages = /** @class */ (function () {
    /**
     * Create a VirtualMachineImages.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    function VirtualMachineImages(client) {
        this.client = client;
    }
    VirtualMachineImages.prototype.get = function (location, publisherName, offer, skus, version, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publisherName: publisherName,
            offer: offer,
            skus: skus,
            version: version,
            options: options
        }, getOperationSpec, callback);
    };
    VirtualMachineImages.prototype.list = function (location, publisherName, offer, skus, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publisherName: publisherName,
            offer: offer,
            skus: skus,
            options: options
        }, listOperationSpec, callback);
    };
    VirtualMachineImages.prototype.listOffers = function (location, publisherName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publisherName: publisherName,
            options: options
        }, listOffersOperationSpec, callback);
    };
    VirtualMachineImages.prototype.listPublishers = function (location, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            options: options
        }, listPublishersOperationSpec, callback);
    };
    VirtualMachineImages.prototype.listSkus = function (location, publisherName, offer, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publisherName: publisherName,
            offer: offer,
            options: options
        }, listSkusOperationSpec, callback);
    };
    return VirtualMachineImages;
}());
export { VirtualMachineImages };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus/{skus}/versions/{version}",
    urlParameters: [
        Parameters.location0,
        Parameters.publisherName,
        Parameters.offer,
        Parameters.skus,
        Parameters.version,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.VirtualMachineImage
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus/{skus}/versions",
    urlParameters: [
        Parameters.location0,
        Parameters.publisherName,
        Parameters.offer,
        Parameters.skus,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.expand0,
        Parameters.top,
        Parameters.orderby,
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: {
                serializedName: "parsedResponse",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageResource"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listOffersOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers",
    urlParameters: [
        Parameters.location0,
        Parameters.publisherName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: {
                serializedName: "parsedResponse",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageResource"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listPublishersOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers",
    urlParameters: [
        Parameters.location0,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: {
                serializedName: "parsedResponse",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageResource"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listSkusOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/publishers/{publisherName}/artifacttypes/vmimage/offers/{offer}/skus",
    urlParameters: [
        Parameters.location0,
        Parameters.publisherName,
        Parameters.offer,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: {
                serializedName: "parsedResponse",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "VirtualMachineImageResource"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=virtualMachineImages.js.map