/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/applicationGatewayPrivateLinkResourcesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a ApplicationGatewayPrivateLinkResources. */
var ApplicationGatewayPrivateLinkResources = /** @class */ (function () {
    /**
     * Create a ApplicationGatewayPrivateLinkResources.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function ApplicationGatewayPrivateLinkResources(client) {
        this.client = client;
    }
    ApplicationGatewayPrivateLinkResources.prototype.list = function (resourceGroupName, applicationGatewayName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            applicationGatewayName: applicationGatewayName,
            options: options
        }, listOperationSpec, callback);
    };
    ApplicationGatewayPrivateLinkResources.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return ApplicationGatewayPrivateLinkResources;
}());
export { ApplicationGatewayPrivateLinkResources };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/applicationGateways/{applicationGatewayName}/privateLinkResources",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.applicationGatewayName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ApplicationGatewayPrivateLinkResourceListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.ApplicationGatewayPrivateLinkResourceListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=applicationGatewayPrivateLinkResources.js.map