import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a AvailablePrivateEndpointTypes. */
export declare class AvailablePrivateEndpointTypes {
    private readonly client;
    /**
     * Create a AvailablePrivateEndpointTypes.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Returns all of the resource types that can be linked to a Private Endpoint in this subscription
     * in this region.
     * @param location The location of the domain name.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailablePrivateEndpointTypesListResponse>
     */
    list(location: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailablePrivateEndpointTypesListResponse>;
    /**
     * @param location The location of the domain name.
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * @param location The location of the domain name.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * Returns all of the resource types that can be linked to a Private Endpoint in this subscription
     * in this region.
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailablePrivateEndpointTypesListByResourceGroupResponse>
     */
    listByResourceGroup(location: string, resourceGroupName: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailablePrivateEndpointTypesListByResourceGroupResponse>;
    /**
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param callback The callback
     */
    listByResourceGroup(location: string, resourceGroupName: string, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * @param location The location of the domain name.
     * @param resourceGroupName The name of the resource group.
     * @param options The optional parameters
     * @param callback The callback
     */
    listByResourceGroup(location: string, resourceGroupName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * Returns all of the resource types that can be linked to a Private Endpoint in this subscription
     * in this region.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailablePrivateEndpointTypesListNextResponse>
     */
    listNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailablePrivateEndpointTypesListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * Returns all of the resource types that can be linked to a Private Endpoint in this subscription
     * in this region.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.AvailablePrivateEndpointTypesListByResourceGroupNextResponse>
     */
    listByResourceGroupNext(nextPageLink: string, options?: msRest.RequestOptionsBase): Promise<Models.AvailablePrivateEndpointTypesListByResourceGroupNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listByResourceGroupNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listByResourceGroupNext(nextPageLink: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AvailablePrivateEndpointTypesResult>): void;
}
//# sourceMappingURL=availablePrivateEndpointTypes.d.ts.map