/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/loadBalancerProbesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a LoadBalancerProbes. */
var LoadBalancerProbes = /** @class */ (function () {
    /**
     * Create a LoadBalancerProbes.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function LoadBalancerProbes(client) {
        this.client = client;
    }
    LoadBalancerProbes.prototype.list = function (resourceGroupName, loadBalancerName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            loadBalancerName: loadBalancerName,
            options: options
        }, listOperationSpec, callback);
    };
    LoadBalancerProbes.prototype.get = function (resourceGroupName, loadBalancerName, probeName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            loadBalancerName: loadBalancerName,
            probeName: probeName,
            options: options
        }, getOperationSpec, callback);
    };
    LoadBalancerProbes.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return LoadBalancerProbes;
}());
export { LoadBalancerProbes };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.loadBalancerName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.LoadBalancerProbeListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes/{probeName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.loadBalancerName,
        Parameters.probeName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.Probe
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.LoadBalancerProbeListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=loadBalancerProbes.js.map