import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a ServiceTagInformationOperations. */
export declare class ServiceTagInformationOperations {
    private readonly client;
    /**
     * Create a ServiceTagInformationOperations.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Gets a list of service tag information resources with pagination.
     * @param location The location that will be used as a reference for cloud (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param [options] The optional parameters
     * @returns Promise<Models.ServiceTagInformationListResponse>
     */
    list(location: string, options?: Models.ServiceTagInformationListOptionalParams): Promise<Models.ServiceTagInformationListResponse>;
    /**
     * @param location The location that will be used as a reference for cloud (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.ServiceTagInformationListResult>): void;
    /**
     * @param location The location that will be used as a reference for cloud (not as a filter based
     * on location, you will get the list of service tags with prefix details across all regions but
     * limited to the cloud that your subscription belongs to).
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: Models.ServiceTagInformationListOptionalParams, callback: msRest.ServiceCallback<Models.ServiceTagInformationListResult>): void;
    /**
     * Gets a list of service tag information resources with pagination.
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param [options] The optional parameters
     * @returns Promise<Models.ServiceTagInformationListNextResponse>
     */
    listNext(nextPageLink: string, options?: Models.ServiceTagInformationListNextOptionalParams): Promise<Models.ServiceTagInformationListNextResponse>;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param callback The callback
     */
    listNext(nextPageLink: string, callback: msRest.ServiceCallback<Models.ServiceTagInformationListResult>): void;
    /**
     * @param nextPageLink The NextLink from the previous successful call to List operation.
     * @param options The optional parameters
     * @param callback The callback
     */
    listNext(nextPageLink: string, options: Models.ServiceTagInformationListNextOptionalParams, callback: msRest.ServiceCallback<Models.ServiceTagInformationListResult>): void;
}
//# sourceMappingURL=serviceTagInformationOperations.d.ts.map